local JSON = require "main.persistence.Json"

PersistenceManager = {}

local function open_file(fileName, mode)
	local file, error1 = assert(io.open(fileName, mode));
	return file;
end

local function close_file(file_streem)
	if file_streem then 
		file_streem:close();
	end
end

local function parseJson(file)
	if file then
		return JSON.decode(file:read("a"));
	else
		return nil
	end
end

local function writeJson(table, file)
	if file then 
		file:write(JSON.encode(table));
	end
end

function PersistenceManager.save(path, data)
	-- C:\Users\Avetis\AppData\Roaming\Nanogram\levelData.json
	-- local filename = sys.get_save_file("Nanogram", "levelData.json");
	
	local file = open_file(path, "w+");
	writeJson(data, file);
	close_file(file);
end

function PersistenceManager.load(path)
	local file = open_file(path, "r");
	local parcedData = parseJson(file);
	close_file(file)
	return parcedData;
end

return PersistenceManager;